
Imports System.Diagnostics
Imports System
Imports System.IO
Imports System.Collections

Public Class Form1

    ' Programmazione Carlo Barabucci Fifteen 15 il GIOCO 2018, puzzle da 2x2 a 10x10

    Inherits System.Windows.Forms.Form

    Dim MioDebugON As Boolean = False ' se true attiva il salvataggio di MioLog.txt nella cartella dell'applicazione
    Dim Ciclo1 As Short ' cicli vari
    Dim Ciclo2 As Short ' cicli vari
    Dim Partenza As Date = DateTime.Now  ' data e ora di inizio gioco
    Dim ClicX As Short ' coordinata X della casella cliccata
    Dim ClicY As Short ' coordinata Y della casella cliccata
    Dim DiffCaselleX As Short ' distanza orizzontale tra la casella vuota e la casella cliccata
    Dim DiffCaselleY As Short ' distanza verticale tra la casella vuota e la casella cliccata
    Dim Casella As Short ' indice della casella cliccata
    Dim VuotoX As Short ' coordinate cha avrebbe una casella vuota
    Dim VuotoY As Short ' coordinate cha avrebbe una casella vuota
    Dim PosVuoto As Short ' posizione del "XX" in SequenzaGenerata
    Dim Tempo As Date ' data e ora letta ogni 100 millisecondi
    Dim SequenzaGenerata As String ' sequenza in formato "010203..." XX = casella vuota,  il DNA del programma
    Dim Mosse As Integer = 0
    Dim pictTasto(100) As PictureBox ' le 15 e + caselle
    Dim imgbmp As Bitmap = Nothing
    Dim DimTessera As Integer = 56 ' funziona per il ridimensionamento
    Dim NumColonne As Short = 4 'minimo 2 max 10
    Dim NumRighe As Short = 4 'minimo 2 max 10
    Dim Velocita As Short = 8 ' velocit scorrimento, viene normalizzata su Form1.load
    Dim Rnd1 As New Random()
    Dim MescolaReale As Boolean ' cambia il comportamento di PictTasto_OnClick quando si mescola
    Dim SpostaMultiploX(11) As Short ' informazioni di spostamento documentate su PictTasto_OnClick
    Dim SpostaMultiploY(11) As Short ' informazioni di spostamento documentate su PictTasto_OnClick
    Dim ElementiArrayCodice As Integer = 11 ' numero di elementi inseriti manualmente da codice

    ' aggiungi le sequenze preferite con il loro nome, le sequenze aggiunte verranno automaticamente gestite
    ' Dopo il caricamento ArraySequenze sar (1,11) a(0,x) le sequenza a (1,x) i nomi (solo puzzle 4x4)

    Dim ArraySequenze(,) As String = {{"010203040506070809101112131415XX",
                                       "XX010203040506070809101112131415",
                                       "010509130206101403071115040812XX",
                                       "XX040812010509130206101403071115",
                                       "010203041213140511XX150610090807",
                                       "011211100213XX090314150804050607",
                                       "XX111009011215080213140703040506",
                                       "010809XX020710150306111404051213",
                                       "XX070815010609140205101303041112",
                                       "010203040807060509101112XX151413",
                                       "XX010203070605040809101115141312",
                                       "0102050604030807091013141211XX15"}, {"Classica",
                                                                             "Sam Loyd",
                                                                             "Verticale",
                                                                             "Verticale inversa",
                                                                             "Spirale orario",
                                                                             "Spirale antiorario",
                                                                             "Spirale inversa",
                                                                             "ZigZag Verticale",
                                                                             "ZigZag Verticale inversa",
                                                                             "ZigZag",
                                                                             "ZigZag inversa",
                                                                             "Tiled"}}

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        MioDebug("! Programma chiuso")

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.Visible = False ' evita la visibilt della preparazione del form

        MioDebug("-----------------------------") ' scrive solo se MioDebugOn = true
        MioDebug("Programma avviato ver 3.4.0.0")
        MioDebug("-----------------------------")

        NuovoPuzzle()

    End Sub

    Private Sub NuovoPuzzle()

        Dim Tessere As Integer
        Dim OffSetTop As Integer = 56
        Dim OffSetLeft As Integer = 36
        Dim Risposta As String = "10x10x56"

        '  input spartano 

        DialogResult = InputBox("COLONNE e RIGHE Min-Max 2-10 DimTessera 20-80", "scegli la dimensione del Puzzle: 2x2 o 3x2 o 5x6 o 6x3 ecc.", Risposta)
        If DialogResult = 2 Then End

        Try
            Dim sep1 As Short = Risposta.IndexOf("x")
            Dim sep2 As Short = Risposta.IndexOf("x", sep1 + 1)
            Dim carattere1 As String = Risposta.Substring(0, sep1)
            Dim carattere2 As String = ""
            Dim carattere3 As String = "56"
            If sep2 = -1 Then
                carattere2 = Risposta.Substring(sep1 + 1)
            Else
                carattere2 = Risposta.Substring(sep1 + 1, sep2 - sep1 - 1)
                carattere3 = Risposta.Substring(sep2 + 1)
            End If
            If Convert.ToInt32(carattere1) < 2 Or Convert.ToInt32(carattere1) > 10 Or Convert.ToInt32(carattere2) < 2 Or Convert.ToInt32(carattere2) > 10 Then
                MessageBox.Show("Fuori range, user 4x4x56")
            Else
                NumRighe = Convert.ToInt32(carattere2)
                NumColonne = Convert.ToInt32(carattere1)
            End If

            If Convert.ToInt32(carattere3) < 20 Or Convert.ToInt32(carattere3) > 80 Then
                DimTessera = 56
            Else
                DimTessera = Convert.ToInt32(carattere3)
            End If
        Catch ex As Exception
            If NumRighe < 2 Or NumRighe > 10 Or NumColonne < 2 Or NumColonne > 10 Then
                MessageBox.Show("Fuori range, user 4x4x56")
            Else
                DimTessera = 56
            End If
        End Try
        '-----------------------------------------------------------------------------------------------
        MioDebug("! Genero un nuovo puzzle: " & NumColonne & "x" & NumRighe & "x" & DimTessera)

        RectangleShape1.Width = DimTessera * NumColonne + 7 ' piccoli aggiustamenti perch la RectangleShape1 la voglio pi grande di PictureBox1
        RectangleShape1.Height = DimTessera * NumRighe + 7
        RectangleShape1.Top = OffSetTop - 4
        RectangleShape1.Left = OffSetLeft - 4
        PictureBox1.Width = DimTessera * NumColonne ' PictureBox1 far da contenitore a picTasto()
        PictureBox1.Height = DimTessera * NumRighe
        PictureBox1.Top = OffSetTop
        PictureBox1.Left = OffSetLeft

        Me.Width = PictureBox1.Width + OffSetLeft * 2
        Me.Height = PictureBox1.Height + 240
        lblinfo.Left = RectangleShape1.Left
        lblinfo.Width = RectangleShape1.Width
        shpMescolaReale.Top = PictureBox1.Height + 87
        cmdMescolaReale.Top = PictureBox1.Height + 90
        shpMescolaReale.Left = RectangleShape1.Left
        cmdMescolaReale.Left = RectangleShape1.Left + 5
        shpMescolaReale.Width = RectangleShape1.Width
        cmdMescolaReale.Width = RectangleShape1.Width - 10
        btnNuovo.Top = PictureBox1.Height + 180
        btnNuovo.Left = RectangleShape1.Left + 5
        btnNuovo.Width = RectangleShape1.Width - 10

        For Tessere = 0 To NumColonne * NumRighe - 2
            pictTasto(Tessere) = New PictureBox ' creo le n. PictureBox
            pictTasto(Tessere).Size = New Size(DimTessera, DimTessera)
            pictTasto(Tessere).Name = "Tes" & Tessere.ToString ' parametro inutilizzto
            pictTasto(Tessere).BackgroundImage = ImageList1.Images.Item(0) ' tutte con lo stesso sfondo
            pictTasto(Tessere).BackgroundImageLayout = ImageLayout.Zoom ' adatta lo sfondo al ridimensionamento
            pictTasto(Tessere).Left = DimTessera * (Tessere Mod NumColonne) ' ccordinata X calcolata
            pictTasto(Tessere).Top = DimTessera * (Math.Ceiling(Tessere \ (NumRighe + NumColonne - NumRighe))) ' coordinata Y calcolata
            pictTasto(Tessere).Tag = Tessere + 1 ' corrispondenza immagine con numero rappresentato
            Me.PictureBox1.Controls.Add(pictTasto(Tessere)) ' aggiungo a PictureBox1 usato come contenitore per avere le coordinate invariate anche se si sposta il puzzle nel form
            AddHandler pictTasto(Tessere).Click, AddressOf PictTasto_OnClick ' permette di avere l'evento click

            imgbmp = New Bitmap(DimTessera, DimTessera) ' creo una bitmap
            Using g As Graphics = Graphics.FromImage(imgbmp) ' g agisce su imgbmp
                g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
                Dim Testo As String = Tessere + 1.ToString ' testo da scrivere
                If Testo.Length = 1 Then Testo = " " & Testo 'centratura
                Using Carattere As Font = New Font("Arial", DimTessera \ 2, FontStyle.Regular)
                    g.DrawString(Testo, Carattere, Brushes.DarkRed, New PointF(2, DimTessera / 8 + 3)) ' ombra ressa scura
                    g.DrawString(Testo, Carattere, Brushes.LightYellow, New PointF(0, DimTessera / 8)) ' numero giallo chiaro
                End Using
            End Using
            pictTasto(Tessere).Image = imgbmp ' la bitmap creata con il numero, caricata sulla corrispondente picturebox()

            SequenzaGenerata = SequenzaGenerata & (Tessere + 100 + 1).ToString.Substring(1, 2) 'sequenza delle 15 e pi caselle il +100 per aggiungere lo zero = Format(tessere, "00"), in Vb.NET?
        Next Tessere

        SequenzaGenerata = SequenzaGenerata & "XX"  ' aggiungo la casella vuota: XX = casella vuota
        Debug.Print(SequenzaGenerata)

        If IO.File.Exists(Application.StartupPath & "\sequenze.txt") Then
            Debug.Print("Leggo dal file """ & Application.StartupPath & "\sequenze.txt"" le sequenze salvate")
            MioDebug("! Leggo dal file """ & Application.StartupPath & "\sequenze.txt"" le sequenze salvate")
            Dim SequenzeInFile As System.IO.StreamReader
            SequenzeInFile = My.Computer.FileSystem.OpenTextFileReader(Application.StartupPath & "\sequenze.txt")
            Dim Letto As String = SequenzeInFile.ReadLine()

            Do Until Letto = Nothing

                Debug.Print("Letto nel file " & Letto)
                MioDebug("! sequenza letta da file: " & Letto)
                Dim Elementi As Integer = ArraySequenze.GetUpperBound(1) + 1
                ReDim Preserve ArraySequenze(1, Elementi)
                ArraySequenze(0, Elementi) = Letto.Substring(0, 32)
                ArraySequenze(1, Elementi) = Letto.Substring(33)
                Letto = SequenzeInFile.ReadLine()

            Loop
            SequenzeInFile.Close()
        Else
            Debug.Print("il file """ & Application.StartupPath & "\sequenze.txt"" non esiste")
            MioDebug("? il file """ & Application.StartupPath & "\sequenze.txt"" non esiste")
        End If

        Dim iCombo As Short
        For iCombo = 0 To ArraySequenze.GetUpperBound(1) ' popolo il combo con i nomi delle sequenze
            ComboBox1.Items.Add(ArraySequenze(1, iCombo))
        Next iCombo

        '----------- PROVVISORIO PER RICONOSCERE LA VITTORIA CON PUZZLE DIVERSO DA 4x4 
        '----------- E DISABILITARE TASTI NON GESTITI CON PUZZLE DIVERSI DA 4x4x56
        If NumColonne <> 4 Or NumRighe <> 4 Or DimTessera <> 56 Then
            lblinfo.Text = "Puzzle " & NumColonne & "x" & NumRighe & "x" & DimTessera
            Label1.Visible = False
            ComboBox1.Visible = False
            btnAggiungi.Visible = False
            btnElimina.Visible = False
            ReDim Preserve ArraySequenze(1, ArraySequenze.GetUpperBound(1) + 1)
            ArraySequenze(0, ArraySequenze.GetUpperBound(1)) = SequenzaGenerata ' immetto la sequenza tra le vittorie
            ArraySequenze(1, ArraySequenze.GetUpperBound(1)) = NumColonne & "x" & NumRighe & "x" & DimTessera ' nome sequenza
            MioDebug("! Puzzle generato sequenza aggiunta: " & ArraySequenze(1, ArraySequenze.GetUpperBound(1)) & " = " & ArraySequenze(0, ArraySequenze.GetUpperBound(1)))
        Else
            lblinfo.Text = "GIOCO del 15"
            Label1.Visible = True
            ComboBox1.Visible = True
            btnAggiungi.Visible = True
            btnElimina.Visible = False
            MioDebug("! Puzzle generato")
        End If
        '------------------------------------------------------------------------------

        Me.Visible = True ' mostra il contenuto del form

        ' rendo i valori Velocit DimTesserea divisibili,
        ' cambiando il valore velocit con il valore maggiore + vicino
        ' evita uno scorrimento al di fuori del range previsto se vengono inseriti valori errati
        ' il codice gestisce il ridimensionamento

        Velocita = DimTessera * 0.25

        If Velocita > DimTessera Then
            Velocita = DimTessera
        ElseIf DimTessera Mod Velocita = 0 Then
            Debug.Print(Velocita)
        Else
            Do Until DimTessera Mod Velocita = 0
                Velocita += 1
            Loop
            Debug.Print(Velocita)
        End If

    End Sub

    Private Sub btnNuovo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNuovo.Click

        Dim Tessere As Integer

        Me.Visible = False ' evita la visibilt della preparazione del form

        For Tessere = 0 To NumColonne * NumRighe - 2
            Me.PictureBox1.Controls.Remove(pictTasto(Tessere)) ' rimuovo da PictureBox1 le tessere
            RemoveHandler pictTasto(Tessere).Click, AddressOf PictTasto_OnClick ' rimuovo l'evento click
        Next Tessere
        SequenzaGenerata = ""
        NumColonne = 4
        NumRighe = 4
        DimTessera = 56
        Mosse = 0
        ComboBox1.Items.Clear()
        ReDim Preserve ArraySequenze(1, ElementiArrayCodice)

        NuovoPuzzle()

    End Sub

    Private Sub cmdMescolaReale_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdMescolaReale.Click

        Dim ciclo As Short
        Dim Numero As Short

        lblinfo.Text = ""
        Mosse = 0
        MescolaReale = True ' cambia il comportamento di PicTasto_OnClick

        ' prima un piccolo spostamento per migliorare il mescolamento
        Call PictTasto_OnClick(pictTasto(CShort(NumColonne * NumRighe - NumColonne)), New System.EventArgs())
        Call PictTasto_OnClick(pictTasto(CShort(0)), New System.EventArgs())
        Call PictTasto_OnClick(pictTasto(CShort(NumColonne - 1)), New System.EventArgs())
        Call PictTasto_OnClick(pictTasto(CShort(NumColonne * NumRighe - 2)), New System.EventArgs())
        Call PictTasto_OnClick(pictTasto(CShort(NumColonne * NumRighe - NumColonne * 2)), New System.EventArgs())
        Call PictTasto_OnClick(pictTasto(CShort(1)), New System.EventArgs())
        Call PictTasto_OnClick(pictTasto(CShort(NumColonne * 2 - 1)), New System.EventArgs())
        ' poi a caso
        For ciclo = 1 To 55 * NumColonne * NumRighe
            Numero = Rnd1.Next(0, (NumColonne * NumRighe) - 1) ' una casella da 0 a 14 se puzzle 4x4
            Call PictTasto_OnClick(pictTasto(CShort(Numero)), New System.EventArgs()) ' chiamo la routine che verifica se le caselle si possono muovere
            lblinfo.Text = CStr(Mosse) ' visualizzo il numero delle mosse fatte
            If ciclo Mod 9 = 0 Then
                lblinfo.Refresh() ' rendo visibile l'avanzamento delle mosse
                PictureBox1.Refresh() ' rendo visibile il movimento delle caselle
            End If
        Next ciclo
        MescolaReale = False

        Partenza = DateTime.Now 'memorizzo la data e l'ora di partenza, serve per calcolare il tempo trascorso
        Mosse = 0
        Label1.Text = "click su una casella numerata"
        Timer1.Enabled = True ' fa scorrere il tempo
        lblinfo.BackColor = Color.White
        shpMescolaReale.Visible = True

    End Sub

    Private Sub PictTasto_OnClick(ByVal sender As System.Object, ByVal e As System.EventArgs)

        ClicX = sender.Left ' coordinata X della casella cliccata
        ClicY = sender.Top ' coordinata Y della casella cliccata
        Casella = sender.tag() - 1 ' indice della casella cliccata su variabile globale per uso in altre routine, tag base1, indice base0

        TrovaVuoto(SequenzaGenerata) ' mette in VuotoX e VuotoY le coordinate della casella vuota, e in PosVuoto la posizione in sequenzagenerata
        DiffCaselleX = 0
        DiffCaselleY = 0

        ' 4 sono le combinazioni gestite:
        ' 1) la casella pu scorrere a destra
        ' 2) la casella pu scorrere a sinstra
        ' 3) la casella pu scorrere in alto
        ' 4) la casella pu scorrere in basso

        If VuotoX = ClicX Then 'combinazione(3-4)
            DiffCaselleY = VuotoY - ClicY ' distanza vuoto, casella, negativa o positiva
            ' la casella pu scorrere in verticale 

            'SpostaMultiploY(0) e SpostaMultiploX(0) quante caselle dovr muovere in timer2 (0,1,2,3), zero = nessuna
            'SpostaMultiploY(1) e SpostaMultiploX(1) indice/valore della casella1
            'SpostaMultiploY(2) e SpostaMultiploX(2) indice/valore della casella2
            'SpostaMultiploY(3) e SpostaMultiploX(3) indice/valore della casella3
            'SpostaMultiploY(4) e SpostaMultiploX(4) indice/valore della casella4
            'SpostaMultiploY(5) e SpostaMultiploX(5) indice/valore della casella5
            'SpostaMultiploY(6) e SpostaMultiploX(6) indice/valore della casella6
            'SpostaMultiploY(7) e SpostaMultiploX(7) indice/valore della casella7
            'SpostaMultiploY(8) e SpostaMultiploX(8) indice/valore della casella8
            'SpostaMultiploY(9) e SpostaMultiploX(9) indice/valore della casella9
            'SpostaMultiploY(10) e SpostaMultiploX(10) -1 per decrementare le coordinate, +1 per incrementarle

            SpostaMultiploY(0) = Math.Abs(DiffCaselleY / DimTessera) 'quante caselle devo spostare
            SpostaMultiploX(0) = 0 'no in orizzontale

            If DiffCaselleY > 0 Then 'combinazione(4)
                SpostaMultiploY(10) = 1 ' spostameto positivo
                Select Case SpostaMultiploY(0) ' quante caselle devo spostare

                    Case Is = 1
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = -1
                        SpostaMultiploY(3) = -1
                        SpostaMultiploY(4) = -1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 2
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = -1
                        SpostaMultiploY(4) = -1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 3
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = -1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 4
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 5
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 6
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 7
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 12 - 2, 2)) - 1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 8
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 12 - 2, 2)) - 1
                        SpostaMultiploY(8) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 14 - 2, 2)) - 1
                        SpostaMultiploY(9) = -1

                    Case Is = 9
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 12 - 2, 2)) - 1
                        SpostaMultiploY(8) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 14 - 2, 2)) - 1
                        SpostaMultiploY(9) = CShort(SequenzaGenerata.Substring(PosVuoto - NumColonne * 16 - 2, 2)) - 1

                End Select
            Else 'combinazione(3)
                SpostaMultiploY(10) = -1 ' spostameto negativo
                Select Case SpostaMultiploY(0) ' quante caselle devo spostare

                    Case Is = 1 'casella singola
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = -1
                        SpostaMultiploY(3) = -1
                        SpostaMultiploY(4) = -1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 2 ' coppia di caselle
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = -1
                        SpostaMultiploY(4) = -1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 3 ' tre caselle
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = -1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 4
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = -1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 5
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = -1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 6
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = -1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 7
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 12 - 2, 2)) - 1
                        SpostaMultiploY(8) = -1
                        SpostaMultiploY(9) = -1

                    Case Is = 8
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 12 - 2, 2)) - 1
                        SpostaMultiploY(8) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 14 - 2, 2)) - 1
                        SpostaMultiploY(9) = -1

                    Case Is = 9
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 4 - 2, 2)) - 1
                        SpostaMultiploY(4) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 6 - 2, 2)) - 1
                        SpostaMultiploY(5) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 8 - 2, 2)) - 1
                        SpostaMultiploY(6) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 10 - 2, 2)) - 1
                        SpostaMultiploY(7) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 12 - 2, 2)) - 1
                        SpostaMultiploY(8) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 14 - 2, 2)) - 1
                        SpostaMultiploY(9) = CShort(SequenzaGenerata.Substring(PosVuoto + NumColonne * 16 - 2, 2)) - 1

                End Select
            End If
            Mosse += 1
            If MescolaReale Then EsegueSpostamento() Else Timer2.Enabled = True ' in fase di mescolamento non si esegue la routine con lo scorrimento
        End If

        If VuotoY = ClicY Then 'combinazione(1-2)
            DiffCaselleX = VuotoX - ClicX ' di quanto pu scorrere negativo positivo
            ' la casella pu scorrere in orizzontale

            SpostaMultiploX(0) = Math.Abs(DiffCaselleX / DimTessera)
            SpostaMultiploY(0) = 0 ' niente in verticale
            If DiffCaselleX > 0 Then ' combinazione(1)
                SpostaMultiploX(10) = 1 ' spostameto positivo
                Select Case SpostaMultiploX(0) ' quante caselle devo spostare

                    Case Is = 1
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = -1
                        SpostaMultiploX(3) = -1
                        SpostaMultiploX(4) = -1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 2
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = -1
                        SpostaMultiploX(4) = -1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 3
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = -1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 4
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto - 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 5
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto - 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 6
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto - 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto - 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 7
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto - 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto - 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = CShort(SequenzaGenerata.Substring(PosVuoto - 6 * 2 - 2, 2)) - 1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 8
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto - 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto - 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = CShort(SequenzaGenerata.Substring(PosVuoto - 6 * 2 - 2, 2)) - 1
                        SpostaMultiploX(8) = CShort(SequenzaGenerata.Substring(PosVuoto - 7 * 2 - 2, 2)) - 1
                        SpostaMultiploX(9) = -1

                    Case Is = 9
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto - 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto - 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = CShort(SequenzaGenerata.Substring(PosVuoto - 6 * 2 - 2, 2)) - 1
                        SpostaMultiploX(8) = CShort(SequenzaGenerata.Substring(PosVuoto - 7 * 2 - 2, 2)) - 1
                        SpostaMultiploX(9) = CShort(SequenzaGenerata.Substring(PosVuoto - 8 * 2 - 2, 2)) - 1

                End Select
            Else ' combinazione(2)
                SpostaMultiploX(10) = -1 ' spostameto negativo
                Select Case SpostaMultiploX(0) ' quante caselle devo spostare e quali

                    Case Is = 1
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = -1
                        SpostaMultiploX(3) = -1
                        SpostaMultiploX(4) = -1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 2
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = -1
                        SpostaMultiploX(4) = -1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 3
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = -1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 4
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto + 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = -1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 5
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto + 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = -1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 6
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto + 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto + 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = -1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 7
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto + 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto + 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = CShort(SequenzaGenerata.Substring(PosVuoto + 6 * 2 - 2, 2)) - 1
                        SpostaMultiploX(8) = -1
                        SpostaMultiploX(9) = -1

                    Case Is = 8
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto + 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto + 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = CShort(SequenzaGenerata.Substring(PosVuoto + 6 * 2 - 2, 2)) - 1
                        SpostaMultiploX(8) = CShort(SequenzaGenerata.Substring(PosVuoto + 7 * 2 - 2, 2)) - 1
                        SpostaMultiploX(9) = -1

                    Case Is = 9
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1
                        SpostaMultiploX(4) = CShort(SequenzaGenerata.Substring(PosVuoto + 3 * 2 - 2, 2)) - 1
                        SpostaMultiploX(5) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploX(6) = CShort(SequenzaGenerata.Substring(PosVuoto + 5 * 2 - 2, 2)) - 1
                        SpostaMultiploX(7) = CShort(SequenzaGenerata.Substring(PosVuoto + 6 * 2 - 2, 2)) - 1
                        SpostaMultiploX(8) = CShort(SequenzaGenerata.Substring(PosVuoto + 7 * 2 - 2, 2)) - 1
                        SpostaMultiploX(9) = CShort(SequenzaGenerata.Substring(PosVuoto + 8 * 2 - 2, 2)) - 1

                End Select
            End If
            Mosse += 1
            If MescolaReale Then EsegueSpostamento() Else Timer2.Enabled = True ' in fase di mescolamento non si esegue la routine con lo scorrimento
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick

        Tempo = DateTime.FromOADate(DateTime.Now.ToOADate - Partenza.ToOADate) ' calcolo del tempo trascorso (con Now il tempo viene correttamente calcolato anche a cavallo della mezzanotte e si pu anche includere il numero dei giorni trascorsi, poich Now restituisce la data e l'ora)
        lblinfo.Text = "Tempo " & Tempo & " e " & Mosse & " mosse"

    End Sub

    Private Sub Timer2_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer2.Tick

        Dim Col As Short
        Dim Rig As Short
        Dim Trovato As Boolean = False
        Static a As Short
        Dim nCaselle As Short

        ' DimTessera, Velocita devono essere divisibili

        a = a + Velocita ' controllo avanzamento
        If a > DimTessera Then a = DimTessera ' i controlli vengono fatti usando le coordinate delle picture,  indispensabile che siano multipli di DimTessera

        For nCaselle = 1 To SpostaMultiploY(0) ' quante caselle devo spostare (0,9)
            pictTasto(SpostaMultiploY(nCaselle)).Top = pictTasto(SpostaMultiploY(nCaselle)).Top + Velocita * SpostaMultiploY(10) ' cambia la coordinata Y della casella 
        Next nCaselle

        For nCaselle = 1 To SpostaMultiploX(0) ' quante caselle devo spostare (0,9)
            pictTasto(SpostaMultiploX(nCaselle)).Left = pictTasto(SpostaMultiploX(nCaselle)).Left + Velocita * SpostaMultiploX(10) ' cambia la coordinata X della casella 
        Next nCaselle

        If a = DimTessera Then ' se la casella cliccata  arrivata in posizione
            a = 0 ' azzero per il prossimo scorrimento
            Timer2.Enabled = False ' finiti i controlli non si dovr rientrare in timer2
            ' Console.Beep(200, 1) ' rumore della casella che sbatte
        Else ' altrimenti la casella cliccata sta scorrendo
            Exit Sub ' si esce e timer2 ancora attivo, rientrer aspettando in base al valore di interval, per proseguire lo scorrimento
        End If

        '---------------- Alla fine dello scorrimento ricreo la sequenza -------------

        SequenzaGenerata = ""

        ' Non conosco la nuova disposizione, la ricavo interrogando tutte le posizioni possibili 
        For Rig = 0 To DimTessera * (NumRighe - 1) Step DimTessera
            For Col = 0 To DimTessera * (NumColonne - 1) Step DimTessera
                For Ciclo1 = 0 To NumRighe * NumColonne - 2 ' trovo l'indice della casella nelle coordinate in esame
                    If pictTasto(Ciclo1).Left = Col And pictTasto(Ciclo1).Top = Rig Then
                        Trovato = True ' se troveto resta a false significa che nelle coordinate in esame non c' una casella
                        Exit For ' inutile proseguire
                    End If
                Next Ciclo1
                If Trovato = False Then ' non c'era una casella
                    SequenzaGenerata = SequenzaGenerata & "XX" ' XX  la casella vuota
                Else
                    SequenzaGenerata = SequenzaGenerata & (Ciclo1 + 100 + 1).ToString.Substring(1, 2) ' converto l'indice in stringa da 2 caratteri con zero avanti se serve
                    Trovato = False
                End If
            Next Col
        Next Rig

        Debug.Print(SequenzaGenerata)

        '--------------- Controllo la soluzione --------------------

        Dim iCombo As Short
        For iCombo = 0 To ArraySequenze.GetUpperBound(1)
            If ArraySequenze(0, iCombo) = SequenzaGenerata Then
                Timer1.Enabled = False
                lblinfo.Text = Mosse & " mosse in: " & Tempo
                lblinfo.BackColor = Color.Yellow
                Label1.Text = "HAI RISOLTO la sequenza: " & ArraySequenze(1, iCombo)
                MioDebug("! HAI RISOLTO la sequenza: " & ArraySequenze(1, iCombo))
                Do
                    Windows.Forms.Application.DoEvents() ' permette a timer2 di continuare a spostare la casella mentre suona
                Loop While a = DimTessera ' aspetta che la casella sia arrivata in posizione
                Console.Beep(1000, 50)
                Console.Beep(3000, 50)
                Console.Beep(1000, 50)
                Console.Beep(3000, 100)
                Console.Beep(2000, 500)
                Exit Sub
            Else
                Timer1.Enabled = True
                Label1.Text = "click su una casella numerata"
                lblinfo.BackColor = Color.White
            End If
        Next iCombo

    End Sub

    Private Sub TrovaVuoto(ByVal SequenzaAttuale As String)

        'SequenzaAttuale = "000000000000000000000000000000XX" ' per test calcoli
        PosVuoto = SequenzaAttuale.IndexOf("XX") + 2 ' controllo dove  il XX, aggiungo 2 per lavorare con la seconda posizione, posVuoto  usato anche da PictTasto_OnClick
        VuotoX = ((PosVuoto - 2) / 2 Mod NumColonne) * DimTessera ' calcolo le coordinate X che avrebbe una tessera nella posizione vuota, VuotoX  usato da PictTasto_OnClick
        VuotoY = Math.Ceiling((PosVuoto - 2) / 2 \ (NumRighe + NumColonne - NumRighe)) * DimTessera ' calcolo le coordinate Y che avrebbe una tessera nella posizione vuota,, VuotoY  usato da PictTasto_OnClick

    End Sub

    Private Sub EsegueSpostamento()

        ' codice simile a quello di timer2, senza scorrimento e controllo soluzione
        ' viene eseguito quando si clicca il tasto mescola

        Dim Posizione(15) As Short
        Dim Col As Short
        Dim Rig As Short
        Dim Trovato As Boolean = False
        Dim nCaselle As Short

        For nCaselle = 1 To SpostaMultiploY(0) ' quante caselle devo spostare
            pictTasto(SpostaMultiploY(nCaselle)).Top = pictTasto(SpostaMultiploY(nCaselle)).Top + DimTessera * SpostaMultiploY(10)
        Next nCaselle

        For nCaselle = 1 To SpostaMultiploX(0) ' quante caselle devo spostare
            pictTasto(SpostaMultiploX(nCaselle)).Left = pictTasto(SpostaMultiploX(nCaselle)).Left + DimTessera * SpostaMultiploX(10)
        Next nCaselle

        '---------------- Alla fine dello spostamento ricreo la sequenza -------------

        SequenzaGenerata = ""

        ' Non conosco la nuova disposizione, la ricavo interrogando tutte le posizioni possibili 
        For Rig = 0 To DimTessera * (NumRighe - 1) Step DimTessera
            For Col = 0 To DimTessera * (NumColonne - 1) Step DimTessera
                For Ciclo1 = 0 To NumRighe * NumColonne - 2 ' trovo l'indice della casella nelle coordinate in esame
                    If pictTasto(Ciclo1).Left = Col And pictTasto(Ciclo1).Top = Rig Then
                        Trovato = True ' se trovato rester a false significa che nelle coordinate in esame non c'era una casella
                        Exit For ' inutile proseguire
                    End If
                Next Ciclo1
                If Trovato = False Then ' non c'era una casella
                    SequenzaGenerata = SequenzaGenerata & "XX" ' "XX"  la casella vuota
                Else
                    SequenzaGenerata = SequenzaGenerata & (Ciclo1 + 100 + 1).ToString.Substring(1, 2) ' converto l'indice in stringa da 2 caratteri con zero avanti se serve
                    Trovato = False
                End If
            Next Col
        Next Rig

        Debug.Print(SequenzaGenerata)
    End Sub

    Private Sub VisualizzaSeq(ByVal Sequenza As String)

        Dim Indice As Short = 0
        Dim Ncasella As Short = 0

        ' scompatta la stringa che contiene la sequenza e posiziona le caselle
        If Sequenza = "" Then Exit Sub
        For Ciclo1 = 0 To 30 Step 2 ' la sequenza  lunga 32 caratteri
            If Sequenza.Substring((Ciclo1), 2) = "XX" Then
                Indice += 1 ' incremento l'indice perch dall'indice ricavo le coordinate
            Else
                Ncasella = CShort(Sequenza.Substring((Ciclo1), 2)) ' posizione per posizione converto in indice
                pictTasto(Ncasella - 1).Left = DimTessera * (Indice Mod 4) ' coordinata X calcolata
                pictTasto(Ncasella - 1).Top = DimTessera * (Math.Ceiling(Indice \ 4)) ' coordinata Y calcolata
                Indice += 1
            End If
        Next Ciclo1

        SequenzaGenerata = Sequenza ' dopo aver visualizzato aggiorno la variabile SequenzaGenerata, poich contiene lo stato del gioco 
        shpMescolaReale.Visible = False
        Timer1.Enabled = False ' ferma il tempo
        lblinfo.BackColor = Color.White

    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged

        VisualizzaSeq(ArraySequenze(0, ComboBox1.SelectedIndex)) ' cambia la sequenza visualizzata.
        If ComboBox1.SelectedIndex > ElementiArrayCodice Then    ' se ci sono pi soluzioni di quelle inserite da programma,
            btnElimina.Visible = True                            ' significa che l'utente ha inserito delle soluzioni personalizzate
        Else                                                     ' si attiva il bottone per l'eventuale rimozione
            btnElimina.Visible = False
        End If
        MioDebug("! E' stata scelta la sequenza: " & ArraySequenze(1, ComboBox1.SelectedIndex) & " = " & ArraySequenze(0, ComboBox1.SelectedIndex))

    End Sub

    Private Sub btnElimina_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnElimina.Click

        ' le sequenze inserite dall'utente possono essere eliminate

        MioDebug("! La sequenza: " & ArraySequenze(1, ComboBox1.SelectedIndex) & "  stata eliminata")
        ArraySequenze(1, ComboBox1.SelectedIndex) = "" ' stringa nulla sui nomi
        ArraySequenze(0, ComboBox1.SelectedIndex) = "" ' stringa nulla sulle sequenze
        ComboBox1.Items.Item(ComboBox1.SelectedIndex) = "" ' stringa nulla sul ComboBox1
        Dim SequenzeInFile As System.IO.StreamWriter ' preparo le operazioni sul file
        My.Computer.FileSystem.DeleteFile(Application.StartupPath & "\sequenze.txt") ' cancello il file esistente
        SequenzeInFile = My.Computer.FileSystem.OpenTextFileWriter(Application.StartupPath & "\sequenze.txt", True) ' ne apro uno nuovo, sempre con lo stesso nome
        Dim Volte As Integer
        For Volte = ElementiArrayCodice + 1 To ArraySequenze.GetUpperBound(1)
            If ArraySequenze(0, Volte) <> "" Then SequenzeInFile.WriteLine(ArraySequenze(0, Volte) & " " & ArraySequenze(1, Volte)) ' scrivo sul file tutte le sequenze che non sono state cancellate
        Next Volte
        SequenzeInFile.Close() ' chiudo il file
        MioDebug("! Il file: " & Application.StartupPath & "\sequenze.txt  stato riscritto")

    End Sub

    Private Sub btnAggiungi_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAggiungi.Click

        ' l'utente ha deciso di memorizzare una nuova sequenza

        Dim NomeSequenza As String = "Nuova_" & ComboBox1.Items.Count + 1 ' creo un nome numerico da proporre sull'input
        Dim Elementi As Integer = ArraySequenze.GetUpperBound(1) + 1 ' memorizzo l'ultima posizione usata in matrice

        DialogResult = InputBox("L'attuale disposizione  una soluzione?", "Immetti il nome della soluzione personalizzata", NomeSequenza)
        If NomeSequenza = "" Or DialogResult = 2 Then MioDebug("? Non  stato inserito un nome") : Exit Sub

        ' se l'utente ha scelto un nome, la sequenza verr aggiunta alle matrici, dopo averle ridimensionate.
        ReDim Preserve ArraySequenze(1, Elementi)
        ArraySequenze(0, Elementi) = SequenzaGenerata
        ArraySequenze(1, Elementi) = NomeSequenza

        ' aggiungo anche sul combobox1
        ComboBox1.Items.Add(NomeSequenza)

        Dim SequenzeInFile As System.IO.StreamWriter ' preparo per la scrittura del file
        If My.Computer.FileSystem.FileExists(Application.StartupPath & "\sequenze.txt") Then My.Computer.FileSystem.DeleteFile(Application.StartupPath & "\sequenze.txt") ' se il file esiste lo cancello
        SequenzeInFile = My.Computer.FileSystem.OpenTextFileWriter(Application.StartupPath & "\sequenze.txt", True) ' apro un file in scrittura, sempre con lo stesso nome

        ' scrivo il file da zero
        Dim Volte As Integer
        For Volte = ElementiArrayCodice + 1 To ArraySequenze.GetUpperBound(1)
            If ArraySequenze(0, Volte) <> "" Then SequenzeInFile.WriteLine(ArraySequenze(0, Volte) & " " & ArraySequenze(1, Volte))
        Next Volte
        SequenzeInFile.Close() ' chiudo il file
        MioDebug("! E' stata memorizzata una nuova sequenza: " & NomeSequenza & " = " & SequenzaGenerata)
        MioDebug("! Il file: " & Application.StartupPath & "\sequenze.txt  stato riscritto")

    End Sub

    Private Sub MioDebug(ByVal Messaggio As String)

        If MioDebugON = True Then
            Dim AppLogger As System.IO.StreamWriter ' preparo per la scrittura del file
            AppLogger = My.Computer.FileSystem.OpenTextFileWriter(Application.StartupPath & "\MioLog.txt", True) ' apro un file in scrittura
            Dim OraData As Date = Date.Now.ToString
            AppLogger.WriteLine(OraData & " - " & Messaggio) ' scrivo il file
            AppLogger.Close() ' chiudo il file
        End If

    End Sub

End Class